;script pour Komposer 0.7.10,  JAWS 7, 8 et 9.
;pour Windows XP, Vista et 7.
;crit par Daniel Poiraud, AVH16.
;Dernire mise  jour le 18.08.2009.  22.36

include "gkwidget.jsm" 
include "hjglobal.jsh"
Include "hjconst.jsh"    
Include "common.jsm"

Globals
int iX1, int iY1, int iX2,  int CSS

const
SC_MAXIMIZE     = 0xF030,
WM_SYSCOMMAND = 0x112

Void Function Maximiser ()
var
handle hwnd
let hwnd =GetAppMainWindow (GetCurrentWindow())
SendMessage (hwnd, WM_SYSCOMMAND, SC_MAXIMIZE,0)
EndFunction

Function AutoStartEvent ()
Maximiser ()
let iX1=40
let iY1=100
let iX2 = 220
EndFunction


Script test0 ()
;C +M +!
;SayInteger(QuelleFenetre())
;SayInteger(QuelId())
EndScript


Script ChoixCSS ()
;Alt +G
If QuelleFenetre()==0&&QuelId()==65 then 
SaveCursor()
InvisibleCursor()
MoveTo(iX1,iY1)
SayString(GetObjectName())
Pause()
MoveTo(iX2,iY1)
RouteJawsToInvisible()
If GetObjectName()=="" then 
SayString("Sans classe.") 
else
SayString(GetObjectName())
EndIf
If IsSameScript() then
let CSS=1
LeftMouseButton()
Pause()
{DownArrow}
EndIf
RestoreCursor ()
EndIf
EndScript


Script ChoixHTML ()
;Alt +H
if QuelleFenetre()==0 then
SaveCursor ()
InvisibleCursor()
SpeechOff()
{Alt+o}
Pause()
{p}
Pause()
{RightArrow}
Pause()
{DownArrow}
If IsSameScript() then
Pause()
EnterKey()
EndIf
SpeechOn()
If IsSameScript() then
SayString("Format paragraphe slectionn.")
EndIf
RestoreCursor ()
Endif
EndScript


Script BoutonParcourir ()
;Ctrl +Maj+L
if QuelleFenetre()>=3 then
SaveCursor ()
SetRestriction(1)
InvisibleCursor()
;;;JawsCursor()
var int j, int l, int k, int iX, int iY ,
int iXo, int iYo
if QuelleFenetre()==3 then 
let iXo=38 let iYo= 120  ;38
EndIf
if QuelleFenetre()==4 then 
let iXo=30 let iYo= 80 ; 30
EndIf

let iX= GetWindowRight (GetForegroundWindow()) -iXo
let iY= GetWindowTop (GetForegroundWindow())+iYo
while j<15
If !StringContains(GetObjectName(),"Parcourir") then
let iY=iY+4
MoveTo(iX,iY)
let j=j+1
else
let j=15
endIf
EndWhile
If StringContains(GetObjectName(),"Parcourir") then
MoveTo(iX,iY+10)
SayString(GetObjectName())
		RoutePcToInvisible()
else
SayString("Le bouton Parcourir n'a pas t trouv.")
Endif
RestoreCursor ()
Endif
EndScript

Script ModeSource ()
;Alt +K
if QuelleFenetre()==1 then
SayString("Vous tes en mode source.")
Endif
if QuelleFenetre()==0 then
SpeechOff()
SaveCursor ()
InvisibleCursor()
{Alt+Q}
Pause()
{H}
Pause()
SpeechOn()
SayString("Mode source.")
RestoreCursor ()
Endif
EndScript


Script ModeNormal ()
;Alt +J
if QuelleFenetre()==0 then
SayString("Vous tes en mode normal.")
Endif
if QuelleFenetre()==1 then
SpeechOff()
SaveCursor ()
InvisibleCursor()
{Alt+Q}
Pause()
{n}
Pause()
EnterKey()
Pause()
SpeechOn()
SayString("Mode normal.")
RestoreCursor ()
Endif
EndScript


Void Function KeyPressedEvent (int nKey, string strKeyName, int nIsBrailleKey, int nIsScriptKey)

If QuelleFenetre()==0&&CSS==1 then
if nKey == key_ENTER||nKey == key_escape  then
let CSS = 0
Actualisation ()
Delay(4)
If QuelID()==0 then
SayString("La fentre n'est plus reconnue. Actualisez la page.")
EndIf
EndIf
EndIf
KeyPressedEvent (nKey, strKeyName, nIsBrailleKey, nIsScriptKey)
EndFunction


Script LireBoite ()
;Alt +B
SayControl (GetFocus())
EndScript


void Function FocusChangedEvent (handle FocusWindow, handle PrevWindow)
var
	handle RealWindow,
	string RealWindowName,
	handle AppWindow,
	handle ForegroundWindow
var int iActuelID 
let iActuelID =QuelID()
;let iPrecedID=iActuelID
let RealWindow = GetRealWindow (FocusWindow)
let RealWindowName = GetWindowName (RealWindow)
let AppWindow = GetAppMainWindow (FocusWindow)
let ForegroundWindow = GetForegroundWindow()
let GlobalFocusWindow = FocusWindow
if AppWindow
&& AppWindow != GlobalPrevApp
;&& AppWindow != GlobalPrevForegroundWindow
&& AppWindow != FocusWindow then
	If !GlobalWasHjDialog
	|| InHjDialog() then
		If ! HandleCustomAppWindows (AppWindow) then
;;SayString("AppWindow")
		EndIf
	EndIf
endIf
If GlobalPrevRealName != RealWindowName
|| GlobalPrevReal != RealWindow then
	If RealWindow != AppWindow
	&& RealWindow != FocusWindow then
		If !GlobalWasHjDialog
		|| InHjDialog() then
			If !HandleCustomRealWindows(RealWindow) then
				SayWindowTypeAndText (RealWindow)
;;SayString("RealWindow")
			EndIf
		EndIf
	endIf
endIf
If !HandleCustomWindows (FocusWindow) then
;;SayString("FocusedWindow")
SayFocusedWindow ()
EndIf

let GlobalPrevReal = RealWindow
let GlobalPrevRealName = RealWindowName
let GlobalPrevApp = AppWindow
;let GlobalPrevForegroundWindow = ForegroundWindow
let GlobalPrevFocus = FocusWindow
Let GlobalWasHjDialog = InHjDialog ()
EndFunction


Int Function QuelleFenetre () 
SpeechOff()
SaveCursor ()
InvisibleCursor ()
setRestriction(0)
JAWSTopOfFile()
var int j, int f, string sTitre
let sTitre= GetWindowName(GetRealWindow(GetFocus()))
If  (StringContains (sTitre, "Proprits du lien")) then	
let f= 3 ;  liens
ElIf  (StringContains (sTitre, "Proprits de l'image")) then	
let f= 4 ;  images
ElIf  (StringContains (sTitre, "Insrer un tableau")) then	
let f= 5 ;  tableaux
ElIf  (StringContains (sTitre, "diteur des proprits avances")) then	
let f= 6 ;  tableaux avanc
ElIf  FindString (GetRealWindow (GetFocus()), "CasCadeS",s_TOP, s_UNRESTRICTED) then 
let j=GetControlAttributes()
		if j==0 then let f=0 EndIf
		if j==4 then let f=1 EndIf
ElIf  (StringContains (sTitre, "Vrification")) then
let f= 2 ;  vrification orthographique
EndIf
RestoreCursor()
SpeechOn()
Return f
EndFunction


Function Actualisation ()
SpeechOff()
{Alt+F}
Pause()
{i}
Pause()
EnterKey()
Pause()
SpeechOn()
EndFunction



Script Actualiser ()
;Alt +L
if QuelleFenetre()==0 then
SetActiveCursor(1)
;EndIf
Delay(4)
If QuelId()==0 then
Actualisation ()
EndIf
SayString("Actualisation de la page.")
EndIf
EndScript

Int Function QuelID ()
var int j
let j =GetObjectSubTypeCode()
Return j
EndFunction

Script SayCharacter1 ()
;5
SayCharacter()
EndScript

Script SayWord1 ()
;Insert +5
If IsSameScript() then
SpellWord() else
SayWord()
EndIf
EndScript


Script CorrecteurOrthographe ()
; Ctrl +Maj +K
if (QuelleFenetre()!=2) then
SayString("Vous n'tes pas dans le correcteur orthographique")
else
SaveCursor ()
InvisibleCursor ()
SetRestriction(1)
RouteInvisibleToPc ()
if (FindString (GetRealWindow (GetFocus ()), "Absent du dictionnaire", S_TOP, S_UNRESTRICTED)) then   
NextWord ()
NextWord ()
NextWord ()
NextWord ()
var
String mot,
String suite
let mot = GetWord()
let suite = GetToEndOfLine()
if (IsSameScript ()&&StringContains (suite , "Vrification d'orthographe")==false) then
SpellString (mot)
Elif (StringContains (suite , "Vrification d'orthographe")) Then
SayString("Correction orthographique termine")
Else
SayString("Mot mal orthographi")
SayString(mot)
EndIf
EndIf
RestoreCursor ()
EndIf
EndScript


Script HotKeyHelp ()
; Insert +H
If UserBufferIsActive () then
UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, msgHotKey)
EndScript


Script Test ()
;Ctrl +Maj +Y
/*
Var
String TheType,
String TheClass,
Int TheID,
Int TheTypeCode,
Int TheSubTypeCode,
Handle TheHandle,
String TheObjectName
Let TheHandle = GetCurrentWindow()
Let TheType =GetWindowType(GetCurrentWindow())
Let TheID = GetControlID (GetCurrentWindow())
Let TheTypeCode= GetObjectTypeCode (false)  ;ajout
Let TheSubTypeCode= GetObjectSubTypeCode(false, 0) ; ajout
Let TheClass = GetWindowClass(GetCurrentWindow())
Let TheObjectName = GetObjectName()
DlgSelectItemInList("ID controle : "+InttoString(TheID)+"|Classe : "+TheClass+"|Type : "+TheType+"|TypeCode : "+InttoString(TheTypeCode)+"|SubTypeCode : "+InttoString(TheSubTypeCode)+"|Name : "+TheObjectName+"|Handle : "+InttoString(TheHandle),"Dit moi tout",0,0)
*/
EndScript
